//------------------------ detclass.C ----------------------------

#include "vdetclass.h"

#include "TROOT.h"
#include <TFile.h>
#include <TTree.h>
#include <iostream>

using std::cout;     
using std::endl;

ClassImp(Axis)
ClassImp(MyEvent)

void vdetclass(const char* ofname="vdetclass.root", Int_t num=10)
{
    Int_t setnaxes = 3;
    Int_t setnaxchannels = 32;
    
    
    TFile* outfile = new TFile(ofname,"recreate");
    cout << "detwrite: output file " << outfile->GetName() << endl;  

    TTree* tree = new TTree("t","dettree");

    MyEvent* event = new MyEvent();

    tree->Branch("event", &event, 8000,2);
    cout << "detwrite: start loop" << endl;
    
    for (int ievt=0; ievt<num; ++ievt){
        
        cout<< "Event: " << ievt << "\n";
        event->clear();
        
        Int_t nax = 0; // haven't added any yet

        for(int iax = 0; iax < setnaxes; iax++){
            
            Axis* axis = event->AddAxis(iax, setnaxchannels);

            for(int ich = 0; ich < setnaxchannels; ich++){
                axis-> chnum [ich] = ich+5;
                axis-> chdata[ich] = 1.+ich*0.0625;
                cout << "\t\tChannel[" << axis-> chnum[ich] << "]: " << axis-> chdata[ich] << "\n";
            }
            
            cerr << "blah1!\n";
            nax++;            
            
        }// end axis loop

        event->evt   = ievt;
        event->nhps  = 1;
        event->naxis = nax; // should be three
        event->timestamp = 100000+ievt*125;

        tree->Fill();

    }// end events loop

    //delete event;
    cout<< "detwrite: Filled events: " << tree->GetEntries() << endl;
   
    outfile = tree->GetCurrentFile();
    if (outfile) {
        outfile->Write();
        outfile->Close();
    }

}// end jetwrite
